' setup module for melee

DECLARE SUB cprint (t$, r!)
TYPE MSEConfigFile
  soundcard     AS INTEGER
  BaseIO        AS INTEGER
  irq           AS INTEGER
  dma           AS INTEGER
  soundquality  AS INTEGER
END TYPE
TYPE keystype
  lft AS INTEGER
  rgt AS INTEGER
  fwd AS INTEGER
  bck AS INTEGER
  turbo AS INTEGER
  shoot AS INTEGER
  spec AS INTEGER
  laser AS INTEGER
END TYPE
DIM maxstar AS INTEGER, maxexh AS INTEGER, maxshot AS INTEGER
DIM p1k AS keystype
DIM p2k AS keystype

PRINT "Starting up..."

DIM MSEConfig AS MSEConfigFile

sclut$(0) = "NONE       "
sclut$(1) = "GUS        "
sclut$(2) = "SB 1.XX    "
sclut$(3) = "SB 2.XX    "
sclut$(4) = "SBPRO      "
sclut$(5) = "SB16       "
sclut$(6) = "PAS        "

sqlut$(0) = "Poor 16Khz "
sqlut$(1) = "Good 22Khz "
sqlut$(2) = "Best 45Khz "
sqlut$(3) = "Bad  8Khz  "

dmalut$(0) = "0          "
dmalut$(1) = "1          "
dmalut$(2) = "3          "
dmalut$(3) = "5          "
dmalut$(4) = "6          "
dmalut$(5) = "7          "

irqlut$(0) = "2          "
irqlut$(1) = "5          "
irqlut$(2) = "7          "
irqlut$(3) = "10         "
irqlut$(4) = "11         "
irqlut$(5) = "12         "
irqlut$(6) = "15         "

' waste of space, i know, but its 12 am and i wanna get this over with :)
DIM iolut$(528 TO 640)
FOR iniiolut = 528 TO 640 STEP 16
  iolut$(iniiolut) = HEX$(iniiolut) + "h       "
NEXT

OPEN "melee.cfg" FOR BINARY AS #1
IF LOF(1) = 0 THEN
  CLOSE #1: KILL "melee.cfg"
  ' defaults
  MSEConfig.soundcard = 3
  MSEConfig.BaseIO = 544
  MSEConfig.irq = 1
  MSEConfig.dma = 1
  MSEConfig.soundquality = 2
  maxstar = 200
  maxexh = 700
  maxshot = 200
  p1k.lft = &H4B
  p1k.rgt = &H4D ' arrows
  p1k.fwd = &H48
  p1k.bck = &H50
  p1k.turbo = &H38 ' alt
  p1k.shoot = &H1D ' ctrl
  p1k.spec = &H36  ' right shift
  p1k.laser = &H35 ' /

  p2k.lft = &H1E
  p2k.rgt = &H20 ' wasd
  p2k.fwd = &H11
  p2k.bck = &H1F
  p2k.turbo = &H2F   ' V
  p2k.shoot = &H30   ' B
  p2k.spec = &H22    ' G
  p2k.laser = &H23   ' H

  m% = 1
  s% = 1
  p1ai% = 0
  p2ai% = 0
  
  PRINT "Running first time, defaults loaded...";
ELSE
  ' load vals
  GET #1, , MSEConfig
  GET #1, , maxstar
  GET #1, , maxexh
  GET #1, , maxshot
  GET #1, , p1k
  GET #1, , p2k
  GET #1, , m%
  GET #1, , s%
  GET #1, , p1ai%
  GET #1, , p2ai%
  CLOSE #1
  PRINT "Current config loaded...";
END IF
PCOPY 0, 1
SCREEN , , 1, 1

      COLOR 15, 1
      cprint "Ĵ KEYS Ŀ", 10
      cprint " Up/Down arrow: Change selection ", 11
      cprint " Left/Right: Change value        ", 12
      cprint " Enter: Advance to selection     ", 13
      cprint "", 14
      WHILE INKEY$ = "": WEND


GOSUB printbg

ch = 1
sch = 1
cch = 1
nch = 1
DO
  IF ch = 1 THEN COLOR 14, 3 ELSE COLOR 15, 1
  cprint "  Sound        ", 10
  IF ch = 2 THEN COLOR 14, 3 ELSE COLOR 15, 1
  cprint "  Control      ", 11
  IF ch = 3 THEN COLOR 14, 3 ELSE COLOR 15, 1
  cprint "  Network      ", 12
  IF ch = 4 THEN COLOR 14, 3 ELSE COLOR 15, 1
  cprint "  Exit & Save  ", 13
  IF ch = 5 THEN COLOR 14, 3 ELSE COLOR 15, 1
  cprint "  Abort        ", 14
  DO: c$ = INKEY$: LOOP UNTIL c$ > ""
  IF c$ = CHR$(0) + "H" THEN ch = ch - 1
  IF c$ = CHR$(0) + "P" THEN ch = ch + 1
  IF ch < 1 THEN ch = 5
  IF ch > 5 THEN ch = 1

  IF c$ = CHR$(13) THEN
    IF ch = 1 THEN      ' sound
      COLOR 11
      cprint "Ĵ       Ŀ", 7
      COLOR 15: cprint "SOUND ", 7: COLOR 11
      cprint "                            ", 8
      cprint "                            ", 9
      cprint "                            ", 10
      cprint "                            ", 11
      cprint "                            ", 12
      cprint "                            ", 13
      cprint "                            ", 14
      cprint "                            ", 15
      cprint "                            ", 16
      cprint "", 17
      DO
        IF sch = 1 THEN COLOR 14, 3 ELSE COLOR 15, 1
        cprint "  Sound Card: " + sclut$(MSEConfig.soundcard), 9
        IF sch = 2 THEN COLOR 14, 3 ELSE COLOR 15, 1
        IF MSEConfig.BaseIO = &HFFFF THEN
          cprint "  Base I/O:   Autodetect ", 10
        ELSE
          cprint "  Base I/O:   " + iolut$(MSEConfig.BaseIO), 10
        END IF
        IF sch = 3 THEN COLOR 14, 3 ELSE COLOR 15, 1
        IF MSEConfig.irq = &HFF THEN
          cprint "  IRQ:        Autodetect ", 11
        ELSE
          cprint "  IRQ:        " + irqlut$(MSEConfig.irq), 11
        END IF
        IF sch = 4 THEN COLOR 14, 3 ELSE COLOR 15, 1
        IF MSEConfig.dma = &HFF THEN
          cprint "  DMA:        Autodetect ", 12
        ELSE
          cprint "  DMA:        " + dmalut$(MSEConfig.dma), 12
        END IF
        IF sch = 5 THEN COLOR 14, 3 ELSE COLOR 15, 1
        cprint "  Quality:    " + sqlut$(MSEConfig.soundquality), 13
        IF sch = 6 THEN COLOR 14, 3 ELSE COLOR 15, 1
        cprint "       AutoDetect        ", 14
        IF sch = 7 THEN COLOR 14, 3 ELSE COLOR 15, 1
        cprint "          Done           ", 15
       
        DO: c$ = INKEY$: LOOP WHILE c$ = ""
        IF c$ = CHR$(0) + "H" THEN sch = sch - 1
        IF c$ = CHR$(0) + "P" THEN sch = sch + 1
        shift = 0
        IF c$ = CHR$(0) + "K" THEN shift = -1
        IF c$ = CHR$(0) + "M" THEN shift = 1
        IF c$ = CHR$(13) AND sch = 6 THEN
          MSEConfig.BaseIO = &HFFFF
          MSEConfig.irq = &HFF
          MSEConfig.dma = &HFF
          c$ = ""
        END IF
        SELECT CASE sch
          CASE 1
            MSEConfig.soundcard = MSEConfig.soundcard + shift
            IF MSEConfig.soundcard < 0 THEN MSEConfig.soundcard = 6
            IF MSEConfig.soundcard > 6 THEN MSEConfig.soundcard = 0
          CASE 2
            IF MSEConfig.BaseIO = &HFFFF GOTO skipsoundshift
            MSEConfig.BaseIO = MSEConfig.BaseIO + shift * 16
            IF MSEConfig.BaseIO < 528 THEN MSEConfig.BaseIO = 640
            IF MSEConfig.BaseIO > 640 THEN MSEConfig.BaseIO = 528
          CASE 3
            IF MSEConfig.irq = &HFF GOTO skipsoundshift
            MSEConfig.irq = MSEConfig.irq + shift
            IF MSEConfig.irq < 0 THEN MSEConfig.irq = 6
            IF MSEConfig.irq > 6 THEN MSEConfig.irq = 0
          CASE 4
            IF MSEConfig.dma = &HFF GOTO skipsoundshift
            MSEConfig.dma = MSEConfig.dma + shift
            IF MSEConfig.dma < 0 THEN MSEConfig.dma = 5
            IF MSEConfig.dma > 5 THEN MSEConfig.dma = 0
          CASE 5
            MSEConfig.soundquality = MSEConfig.soundquality + shift
            IF MSEConfig.soundquality < 0 THEN MSEConfig.soundquality = 3
            IF MSEConfig.soundquality > 3 THEN MSEConfig.soundquality = 0
        END SELECT
skipsoundshift:
        IF sch < 1 THEN sch = 7
        IF sch > 7 THEN sch = 1
      LOOP UNTIL sch = 7 AND c$ = CHR$(13)
      'IF (MSEConfig.soundcard > 0 AND MSEConfig.soundcard < 2) OR MSEConfig.soundcard > 3 THEN
      '  COLOR 14, 6
      '  cprint "Ĵ WARNING Ŀ", 10
      '  cprint " If sound or music does not sound right  ", 11
      '  cprint " with this sound card, try SB1.xx/2.xx   ", 12
      '  cprint " (on my comp only those work right...)   ", 13
      '  cprint "", 14
      '  WHILE INKEY$ = "": WEND
      'END IF
      IF MSEConfig.soundcard = 0 THEN
        m% = 0: s% = 0
      ELSE
        m% = 1: s% = 1
      END IF

      c$ = ""
      GOSUB printbg
    ELSEIF ch = 2 THEN  ' control
      COLOR 14, 6
      cprint "Ĵ OOPS Ŀ", 11
      cprint " Control reconfig not yet implemented... ", 12
      cprint "", 13
      WHILE INKEY$ = "": WEND
      c$ = ""
      GOSUB printbg
    ELSEIF ch = 3 THEN  ' network
      COLOR 14, 6
      cprint "Ĵ OOPS Ŀ", 11
      cprint " Networking not yet implemented... ", 12
      cprint "", 13
      WHILE INKEY$ = "": WEND
      c$ = ""
      GOSUB printbg
    END IF
  END IF

LOOP UNTIL c$ = CHR$(13)

COLOR 7, 0
CLS
SCREEN , , 0, 0
PRINT

IF ch = 4 THEN
  OPEN "MELEE.CFG" FOR BINARY AS #1
  PUT #1, , MSEConfig
  PUT #1, , maxstar
  PUT #1, , maxexh
  PUT #1, , maxshot
  PUT #1, , p1k
  PUT #1, , p2k
  PUT #1, , m%
  PUT #1, , s%
  PUT #1, , p1ai%
  PUT #1, , p2ai%
  CLOSE #1
 
  PRINT "New config saved."
  PRINT "Type 'MELEE' to play!";
ELSEIF ch = 5 THEN
  PRINT "Setup aborted.";
ELSE
  PRINT "wtf?";
END IF

SYSTEM

printbg:

CLS
COLOR 15, 1
PRINT STRING$(80, " ")
cprint "Setup for Melee by GuPH", 1
COLOR 1, 8
FOR bg = 2 TO 25
  LOCATE bg, 1
  PRINT STRING$(80, "");
NEXT

COLOR 11, 1
cprint "Ĵ      Ŀ", 8
COLOR 15: cprint "MAIN", 8: COLOR 11
cprint "                        ", 9
cprint "                        ", 10
cprint "                        ", 11
cprint "                        ", 12
cprint "                        ", 13
cprint "                        ", 14
cprint "                        ", 15
cprint "", 16

COLOR 8, 0
cprint "     (C) 2000 by GuPH     ", 23

RETURN

SUB cprint (t$, r)
LOCATE r, 40 - LEN(t$) / 2
PRINT t$;
END SUB

