' sound egine routines
' file #20 is module file
' only one mod at a time!!
' by GuPH
'$INCLUDE: 'MELEE.CMN'

DIM SHARED ModHead         AS GDMHeader
DIM SHARED SndDevMSE(6)    AS STRING    ' mseconfigfile type is in .cmn
'DIM SHARED MSEConfig       AS MSEConfigFile
DIM SHARED songfil AS INTEGER

DECLARE FUNCTION initsnd! ()

FUNCTION initsnd
Freemem& = FRE(-1) - 80000
A& = SETMEM(-Freemem&)
'initsnd = 0: EXIT FUNCTION     ' debug

SndDevMSE(1) = "GUS"
SndDevMSE(2) = "SB1X"
SndDevMSE(3) = "SB2X"
SndDevMSE(4) = "SBPRO"
SndDevMSE(5) = "SB16"
SndDevMSE(6) = "PAS"

OPEN "MELEE.CFG" FOR BINARY AS 1
  GET 1, , MSEConfig
CLOSE 1

IF MSEConfig.SoundCard = 0 THEN initsnd = 0: EXIT FUNCTION
MSE$ = SndDevMSE(MSEConfig.SoundCard) + ".MSE"

DIM Ov AS INTEGER
SELECT CASE MSEConfig.SoundQuality
CASE 0: Ov = 16
CASE 1: Ov = 22
CASE 2: Ov = 45
CASE 3: Ov = 8
END SELECT

dummy = gdfget("melee.gdf", MSE$)
                        'MSE$
errflag = LoadMSE(MSE$, 0, Ov, 4096, MSEConfig.BaseIO, MSEConfig.IRQ, MSEConfig.DMA)

  SELECT CASE errflag
  CASE 0
  CASE 1: PRINT "SND: Base I/O address autodetection failure": SYSTEM
  CASE 2: PRINT "SND: IRQ level autodetection failure": SYSTEM
  CASE 3: PRINT "SND: DMA channel autodetection failure": SYSTEM
  CASE 4: PRINT "SND: DMA channel not supported": SYSTEM
  CASE 6: PRINT "SND: Sound device does not respond": SYSTEM
  CASE 7: PRINT "SND: Memory control blocks destroyed": SYSTEM
  CASE 8: PRINT "SND: Insufficient memory for mixing buffers": SYSTEM
  CASE 9: PRINT "SND: Insufficient memory for MSE file": SYSTEM
  CASE 10: PRINT "SND: MSE has invalid identification string (corrupt/non-existant)": SYSTEM
  CASE 11: PRINT "SND: MSE disk read failure": SYSTEM
  CASE 12: PRINT "SND: MVSOUND.SYS not loaded (required for PAS use)": SYSTEM
  CASE 42: PRINT "SND: MSE binary not found": SYSTEM
  CASE ELSE: PRINT "SND: Unknown error on MSE startup" + STR$(errflag): SYSTEM
  END SELECT

initsnd = MSEConfig.SoundCard

KILL MSE$

END FUNCTION

SUB sfxplay (which%, hz&)
' module must always be 4 channels!
PlaySample 4 + sfxchan, which%, hz&, 64, &HFF
' cycle through sfx channels
sfxchan = sfxchan + 1
IF sfxchan > maxsfxchan THEN sfxchan = 1
END SUB

SUB sndbegin (whichsong$)
DIM emsflag AS INTEGER
DIM musicchannels AS INTEGER
IF EmsExist THEN emsflag = 1 ELSE emsflag = 0

songfil = 20

dummy = gdfget("melee.gdf", whichsong$)

OPEN whichsong$ FOR BINARY AS songfil

LoadGDM FILEATTR(songfil, 2), 0, emsflag, VARSEG(ModHead), VARPTR(ModHead)

SELECT CASE emsflag
CASE 0
CASE 1: PRINT "SND: Module is corrupt": SYSTEM
CASE 2: PRINT "SND: Could not autodetect module type": SYSTEM
CASE 3: PRINT "SND: Bad format ID": SYSTEM
' turn off music here
CASE 4: PRINT "SND: Out of memory": 'SYSTEM'            **** DEBUG
CASE 5: PRINT "SND: Cannot unpack samples": SYSTEM
CASE 6: PRINT "SND: AdLib samples not supported": SYSTEM
CASE ELSE: PRINT "SND: Unknown Load Error:" + STR$(emsflag): SYSTEM
END SELECT

musicchannels = 0
FOR J = 1 TO 32
  IF ASC(MID$(ModHead.PanMap, J, 1)) <> &HFF THEN
    musicchannels = musicchannels + 1
  END IF
NEXT

'       4 channels for music [maxsfxchan] channels for sfx
OverRate& = StartOutput(musicchannels + maxsfxchan, 0)
StartMusic

END SUB

SUB sndhalt

StopMusic
StopOutput
UnloadModule
CLOSE songfil

KILL "*.MUS"

'FreeMSE

END SUB

